#!/bin/sh
COUNT="$1"
if [ "${COUNT}" = '' ]; then
	echo "usage: `basename $0` LIST_COUNT"
	exit 1
fi

CRYPTFMT="/opt/rl3/bin/cryptfmt.py"
RL3FMT="/opt/rl3/bin/rl3fmt.sh"
PRODUCT=`cat /var/lib/model | grep '^product	' | cut -f 2`

__new() {
	local PINCODE=`/opt/rl3/bin/pincode.sh new_init`
	local USER="remote"
	local PASS=""
	local DEVNAME="$1"
	[ $? -ne 0 ] && return 1
	local DATA=`${RL3FMT} "${PINCODE}" "${USER}" "${PASS}" | ${CRYPTFMT} encode`
	[ $? -ne 0 ] && return 1
	echo "\"${DATA}\",\"${PINCODE}\",\"${USER}\",\"${PASS}\"",\"${DEVNAME}\"
}

INDEX=0
while [ ${INDEX} -lt ${COUNT} ]; do
	__new "${PRODUCT}" || exit 1
	INDEX=$((INDEX+1))
done
exit 0
