#!/bin/sh -x
PORT1="$1"
PORT2="$2"
UPNP_FLAG="$3"
EXTPORT1="$4"
[ "${EXTPORT1}" = '' ] && EXTPORT1="${PORT1}"
EXTPORT2="$5"
[ "${EXTPORT2}" = '' ] && EXTPORT2="${PORT2}"

[ "${PORT1}" = '' ] && exit 1
[ "${PORT2}" = '' ] && exit 1
[ "${UPNP_FLAG}" = '' ] && exit 1
[ "${EXTPORT1}" = '' ] && exit 1
[ "${EXTPORT2}" = '' ] && exit 1

TEMPLATE=/mnt/hda5/conf/rl3/param.conf.default
TARGET=/mnt/hda5/conf/rl3/param.conf

__get() {
	local KEY="$1"
	grep "^${KEY} *=" | sed "s/^${KEY} *=\(.*\)/\1/"
}

__set() {
	local KEY="$1"
	local VALUE="$2"
	sed "s/^${KEY} *=.*/${KEY}=${VALUE}/"
}

OLD_PORT1=`cat "${TARGET}" | __get TCP_LISTEN_ADDR_DEVICE_1`
OLD_PORT2=`cat "${TARGET}" | __get TCP_LISTEN_ADDR_DEVICE_2`
OLD_UPNP_FLAG=`cat "${TARGET}" | __get UPNP_FLAG`
OLD_EXTPORT1=`cat "${TARGET}" | __get ROUTER_WAN_PORT_1`
OLD_EXTPORT2=`cat "${TARGET}" | __get ROUTER_WAN_PORT_2`

[ "${OLD_PORT1}" = "${PORT1}" \
	-a "${OLD_PORT2}" = "${PORT2}" \
	-a "${OLD_UPNP_FLAG}" = "${UPNP_FLAG}" \
	-a "${OLD_EXTPORT1}" = "${EXTPORT1}" \
	-a "${OLD_EXTPORT2}" = "${EXTPORT2}" \
	] && exit 0

DAEMON=0
pgrep -f /opt/rl3/bin/logd.sh && DAEMON=1
if [ ${DAEMON} -eq 1 ]; then
	/etc/init.d/rl3.sh stop || exit 1
fi

cat "${TEMPLATE}" \
	| __set TCP_LISTEN_ADDR_DEVICE_1 ${PORT1} \
	| __set TCP_LISTEN_ADDR_DEVICE_2 ${PORT2} \
	| __set UPNP_FLAG ${UPNP_FLAG} \
	| __set ROUTER_WAN_PORT_1 ${EXTPORT1} \
	| __set ROUTER_WAN_PORT_2 ${EXTPORT2} \
	> "${TARGET}" || exit 1

if [ ${DAEMON} -eq 1 ]; then
	/etc/init.d/rl3.sh start || exit 1
fi
exit 0
