#!/usr/bin/env python

import cgi
import cgitb
import sys
import os
import uuid
import hashlib
import json
from ionas.request import (Entry, Request)
from fal_info import (FAL_STATEMGR_PATH,)
from product_conf import (SUDO_CMD,)
from product_conf.reqinfo import (ReqTypes, Results)
from status_info import (get_status_list,)

cgitb.enable()


DEVCTRL_SESSION_DIR = "/var/tmp/devctrl/session"


RESPONSE_BASE_DICT = {
        "response": "",
        "lang":  "ja",
        "result": 0,
    }

INVALID_RESPONSE_DICT = {
        "response": "",
        "lang":  "ja",
        "result": 1,
    }


def _request(fal_cmd, entry):
    response = Request(fal_cmd, filter_cmd=SUDO_CMD).request(entry)
    return response.get_entrylist().get_entry().get()


def _update_session_time(session_id):

    os.utime(os.path.join(DEVCTRL_SESSION_DIR, session_id), None)


def check_session(session_id):

    if not session_id:
        raise Exception()

    if not os.path.exists(os.path.join(DEVCTRL_SESSION_DIR, session_id)):
        raise Exception()

    _update_session_time(session_id)


# main
#

print "Content-Type: text/json\n"


try:
    request = json.loads(sys.stdin.read())
    response = dict(RESPONSE_BASE_DICT)
    response["result"] = 1

    if request["request"] == "get_status":
        response["response"] = "get_status"
        response["session_id"] = request["session_id"]
        check_session(request["session_id"])
        response["status_list"] = []
        response["result"] = 0

    print json.dumps(response, indent=1, encoding="utf8",
                                ensure_ascii=False).encode("utf8")
except:
    print json.dumps(INVALID_RESPONSE_DICT, indent=1, encoding="utf8",
                                ensure_ascii=False).encode("utf8")
